Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2483 by niro, Wed Jan 8 10:36:44 2014 UTC revision 2885 by niro, Fri Jul 31 10:09:08 2015 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 72  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61    # -> now in images.conf
62    CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75  ### helper scripts ###  ### helper scripts ###
76    
# Line 100  install_meter() Line 99  install_meter()
99   return 0   return 0
100  }  }
101    
102    mount_rootfs()
103    {
104     local retval
105    
106     if [[ -n ${SWAPHDD} ]]
107     then
108     swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
109     fi
110    
111     if [[ -n ${ROOTHDD} ]]
112     then
113     if is_mounted --location "${INSTALLROOT}"
114     then
115     echo $"${INSTALLROOT} already mounted" >&2
116     else
117     mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
118     fi
119     fi
120    
121     [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
122    
123     if [[ -n ${BOOTHDD} ]]
124     then
125     if is_mounted --location "${INSTALLROOT}"/boot
126     then
127     echo $"${INSTALLROOT}/boot already mounted" >&2
128     else
129     mount "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
130     fi
131     fi
132    }
133    
134    umount_rootfs()
135    {
136     is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
137     is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
138    
139     if [[ -n ${SWAPHDD} ]]
140     then
141     swapoff ${SWAPHDD} || die
142     fi
143    }
144    
145    install_do_reboot()
146    {
147     reboot
148    }
149    
150  run_hardware_detection()  run_hardware_detection()
151  {  {
152   local hwinfo   local hwinfo
153    
154   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
155    
156   ## check for special devices/clients:   # check for special devices/clients:
157   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
158   #local removable=0   local removable=0
159   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
160   #then   then
161   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
162   #do   #do
163   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
164   #then   # then
165   #removable=1   # removable=1
166   #fi   # fi
167   #done   #done
168   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
169    
170   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
171   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
172   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
173   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
174   #then   then
175   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
176   #else   else
177   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
178   #fi   fi
179   #fi   fi
180    
181   # check for special devices/clients:   # check for special devices/clients:
182   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 165  run_hardware_detection_disks() Line 212  run_hardware_detection_disks()
212   # all disks but exclude ramdisks   # all disks but exclude ramdisks
213   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
214   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
215   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
216   then   then
217   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
218   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
219   fi   fi
220   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
221  }  }
222    
223  setup_hdd_partitions_auto()  setup_hdd_partitions()
224  {  {
225   ROOTHDD="${HDD}1"   case "${INSTALL_METHOD}" in
226     auto)
227     BOOTHDD=""
228     SWAPHDD=""
229     ROOTHDD="${HDD}1"
230     ;;
231     normal)
232     BOOTHDD="${HDD}1"
233     SWAPHDD="${HDD}2"
234     ROOTHDD="${HDD}3"
235     ;;
236     esac
237    
238   # sanity check - should not happen   # sanity check - should not happen
239   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
# Line 183  setup_hdd_partitions_auto() Line 241  setup_hdd_partitions_auto()
241   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
242   umount "${ROOTHDD}"   umount "${ROOTHDD}"
243   fi   fi
244     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
245   then   then
246   if hdd_size_below_256mb ${HDD}   if is_mounted --device "${BOOTHDD}"
247   then   then
248   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
249   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
250   fi   fi
251   fi   fi
252    
253   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
254   then   then
255   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
256   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
257   #2. p= primary disk   then
258   #3. 1= first partition   if device_minimum_size "${HDD}" 256
259   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
260   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
261   #6. a= bootable flag   else
262   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
263   #8. w= write/quit   fi
264   fdisk ${HDD} &> /dev/null << EOF   fi
265    
266     ## delete disk
267     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
268    
269     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
270     then
271     ## setup one bootable partition
272     #1. n= new disk
273     #2. p= primary disk
274     #3. 1= first partition
275     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
276     #5. ''= defaul sector end
277     #6. a= bootable flag
278     #7. 1= boot flag for partition 1
279     #8. w= write/quit
280     fdisk ${HDD} &> /dev/null << EOF
281  n  n
282  p  p
283  1  1
# Line 219  a Line 287  a
287  1  1
288  w  w
289  EOF  EOF
290   else   else
291   ## setup one bootable partition   ## setup one bootable partition
292   #1. n= new disk   #1. n= new disk
293   #2. p= primary disk   #2. p= primary disk
294   #3. 1= first partition   #3. 1= first partition
295   #4. ''= default sector start   #4. ''= default sector start
296   #5. ''= defaul sector end   #5. ''= defaul sector end
297   #6. a= bootable flag   #6. a= bootable flag
298   #7. 1= boot flag for partition 1   #7. 1= boot flag for partition 1
299   #8. w= write/quit   #8. w= write/quit
300   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
301  n  n
302  p  p
303  1  1
# Line 239  a Line 307  a
307  1  1
308  w  w
309  EOF  EOF
310     fi
311     else
312     cfdisk ${HDD} || dialog_die
313   fi   fi
314  }  }
315    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
   
316  setup_hdd_format()  setup_hdd_format()
317  {  {
318   # sanity check - should not happen   install -d /tmp
319   if is_mounted --device "${ROOTHDD}"   :> /tmp/format.log
320    
321     if [[ -n ${SWAPHDD} ]]
322   then   then
323   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   # sanity check - should not happen
324   umount "${ROOTHDD}"   if is_mounted --device "${SWAPHDD}"
325     then
326     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
327     umount "${SWAPHDD}"
328     fi
329     mkswap ${SWAPHDD} || die
330   fi   fi
331    
332   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   if [[ -n ${BOOTHDD} ]]
333  }   then
334     # sanity check - should not happen
335     if is_mounted --device "${BOOTHDD}"
336     then
337     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
338     umount "${BOOTHDD}"
339     fi
340    
341  install_mount_rootfs()   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
342  {   fi
343   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
344   install -d ${INSTALLROOT}/boot || dialog_die   if [[ -n ${ROOTHDD} ]]
345     then
346     # sanity check - should not happen
347     if is_mounted --device "${ROOTHDD}"
348     then
349     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
350     umount "${ROOTHDD}"
351     fi
352    
353     mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
354     fi
355  }  }
356    
357  install_system_image()  install_system_image()
358  {  {
359   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
360   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
361   popd > /dev/null   popd > /dev/null
362  }  }
363    
# Line 282  install_system_settings() Line 368  install_system_settings()
368   # write fstab   # write fstab
369   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
370   clearconfig   clearconfig
371   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
372     then
373     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime\t1 1"
374     fi
375     if [[ -n ${ROOTHDD} ]]
376     then
377     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
378     fi
379     if [[ -n ${SWAPHDD} ]]
380     then
381     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
382     fi
383   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
384   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
385    
# Line 293  install_system_settings() Line 390  install_system_settings()
390   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
391    
392   # intel framebuffer quirk   # intel framebuffer quirk
393   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
394     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
395   then   then
396   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
397   then   then
398   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
399   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
400   fi   fi
401   fi   fi
402  }  }
403    
 install_umount_rootfs()  
 {  
  is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot  
  is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}  
 }  
   
 install_do_reboot()  
 {  
  reboot  
 }  
   
404    
405  ### installer dialogs ###  ### installer dialogs ###
406    
# Line 359  task_setup_system_menu() Line 440  task_setup_system_menu()
440   if [[ ${retval} -eq 0 ]]   if [[ ${retval} -eq 0 ]]
441   then   then
442   case "${mode}" in   case "${mode}" in
443   "1") run_install_auto ;;   "1") run_install auto ;;
444   "2") run_install_normal ;;   "2") run_install normal ;;
445   "") task_setup_system_menu;;   "") task_setup_system_menu;;
446   esac   esac
447   fi   fi
# Line 410  task_hardware_detection() Line 491  task_hardware_detection()
491   messagebox -y 12 -h $"Detected hardware:" "${message}"   messagebox -y 12 -h $"Detected hardware:" "${message}"
492  }  }
493    
494  task_setup_hdd_partitions_manual()  task_setup_hdd_partitions()
495  {  {
496   local i   local i
497   local retval   local retval
# Line 426  task_setup_hdd_partitions_manual() Line 507  task_setup_hdd_partitions_manual()
507   if [[ ${retval} -eq 0 ]]   if [[ ${retval} -eq 0 ]]
508   then   then
509   dialog_setup_hdd_info   dialog_setup_hdd_info
510   setup_hdd_partitions_manual   setup_hdd_partitions
  fi  
  fi  
 }  
   
 task_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
511   fi   fi
512   fi   fi
513  }  }
# Line 475  task_main() Line 534  task_main()
534   done   done
535  }  }
536    
537  run_install_normal()  run_install()
538  {  {
539   task_hardware_detection   local method="$1"
   
  task_setup_hdd_partitions_manual  
  dialog_setup_hdd_format  
  setup_hdd_format > /dev/null  
  install_mount_rootfs  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings  
  if is_initrd_supported  
  then  
  dialog_install_initrd  
  initrd_config  
  initrd_install  
  fi  
540    
  dialog_install_bootsector  
  bootloader_config  
  bootloader_install  
   
  install_umount_rootfs  
  dialog_install_successful  
 }  
   
 run_install_auto()  
 {  
541   task_hardware_detection   task_hardware_detection
542    
543   task_setup_hdd_partitions_auto   case "${method}" in
544     auto)
545     export FORMAT_FILESYSTEM_BOOTHDD=""
546     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
547     export INSTALL_METHOD="${method}"
548     ;;
549     normal)
550     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
551     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
552     export INSTALL_METHOD="${method}"
553     ;;
554     single)
555     export FORMAT_FILESYSTEM_BOOTHDD=""
556     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
557     export INSTALL_METHOD="${method}"
558     ;;
559     *)
560     die "Unknown install method '${method}', aborting."
561     ;;
562     esac
563    
564     task_setup_hdd_partitions
565   dialog_setup_hdd_format   dialog_setup_hdd_format
566   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
567   install_mount_rootfs   mount_rootfs
568   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
569    
570   dialog_install_settings   dialog_install_settings
# Line 527  run_install_auto() Line 581  run_install_auto()
581   bootloader_config   bootloader_config
582   bootloader_install   bootloader_install
583    
584   install_umount_rootfs   umount_rootfs
585   dialog_install_successful   dialog_install_successful
586  }  }
587    

Legend:
Removed from v.2483  
changed lines
  Added in v.2885